//IncludeScript("give_tf_weapon/master.nut")
::robot_spy_arms_cache <- [
    "models/mvm/weapons/v_models/v_pda_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_ttg_watch_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_leather_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_pocket_spy_bot.mdl"
    "models/mvm/weapons/v_models/v_watch_spy_bot.mdl"
    "models/mvm/workshop_partner/weapons/v_models/v_hm_watch/v_hm_watch_bot.mdl"
]

::giant_weapon_sound_cache <- [
    "MVM.GiantHeavyGunWindDown"
    "MVM.GiantHeavyGunWindUp"
    "MVM.GiantHeavyGunFire"
    "MVM.GiantHeavyGunSpin"
    "MVM.GiantSoldierRocketShoot"
    "MVM.GiantSoldierRocketShootCrit"
    "MVM.GiantSoldierRocketExplode"
    "MVM.GiantDemoman_Grenadeshoot"
    "MVM.GiantPyro_FlameStart"
    "MVM.GiantPyro_FlameLoop"
]

foreach (_, value in robot_spy_arms_cache)
{
    PrecacheModel(value)
}

foreach (_, value in giant_weapon_sound_cache)
{
    self.PrecacheSoundScript(value)
}

::SlappyHide <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)

    player.ValidateScriptScope()
    local scope6 = player.GetScriptScope()
    scope6.WeaponSoundDelay <- 0
    scope6.WeaponSpinIdleSoundDelay <- 0
    scope6.WeaponSpinFireSoundDelay <- 0

    PrecacheModel("models/weapons/c_models/c_slapping_glove/c_slapping_glove_robo.mdl")
    local ent = null
    local slappy = Entities.FindByClassname(null,"tf_weapon_slap")
    if (slappy != null)
    {
        if (slappy.GetOwner() == player)
        {
            //slappy.Destroy()
            NetProps.SetPropInt(slappy, "m_fEffects", 32)
            NetProps.SetPropInt(slappy, "m_nRenderMode", 10)
            player.GiveWeapon("RobotSlappingHand")
        }
    }
}

::SlappyThink <- function()
{
    local playerslappy = Entities.FindByClassname(null,"tf_weapon_slap")
    if (playerslappy != null)
    {
        if (playerslappy.GetOwner() != null)
        {
            if (playerslappy.GetTeam() != TF_TEAM_RED)
            {
                local slappingglovemodelid = GetModelIndex("models/weapons/c_models/c_slapping_glove/c_slapping_glove.mdl")
                local playerglovemodelid = NetProps.GetPropInt(playerslappy, "m_iWorldModelIndex")
                local slappinggloveworldid = GetModelIndex("models/weapons/c_models/c_slapping_glove/w_slapping_glove.mdl")
                if ((slappingglovemodelid == playerglovemodelid) || (slappinggloveworldid == playerglovemodelid))
                {
                    if (playerslappy.GetScriptThinkFunc() == "")
                    {
                        playerslappy.SetDrawEnabled(false)
                        NetProps.SetPropInt(playerslappy, "m_fEffects", 32)
                        NetProps.SetPropInt(playerslappy, "m_nRenderMode", 10)
                        playerslappy.GetOwner().GiveWeapon("RobotSlappingHand")
                    }
                }
            }
        }
    }

    for (local i = 1; i <= MaxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (player != null)
        {
            for (local i = 0; i < 7; i++)
            {
                local weapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", i);
                local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel");
                if ((player.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (player.GetTeam() == 3))
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if (player.GetActiveWeapon().GetClassname() != "tf_weapon_pda_spy")
                            {
                                NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/mvm/weapons/c_models/c_spy_bot_arms.mdl"))
                            }
                            else if ((weapon.GetClassname() == "tf_weapon_pda_spy") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_pda_spy"))
                            {
                                viewmodel.SetModelSimple(robot_spy_arms_cache[0])
                            }

                            if ((weapon.GetClassname() == "tf_weapon_invis"))
                            {
                                local model
                                local weaponindex = NetProps.GetPropInt(weapon, "m_iWorldModelIndex")
                                if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_spy.mdl") ) {model = robot_spy_arms_cache[4];}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_pocket_spy.mdl")) {model = robot_spy_arms_cache[3];}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_leather_spy.mdl")) {model = robot_spy_arms_cache[2];}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_ttg_watch_spy.mdl")){model = robot_spy_arms_cache[1];}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_hm_watch/v_hm_watch.mdl")){model = robot_spy_arms_cache[5];}
                                else if (weaponindex == GetModelIndex("models/workshop_partner/weapons/v_models/v_hm_watch/v_hm_watch.mdl")){model = robot_spy_arms_cache[5];}

                                local modelIndex = GetModelIndex( model )
                                weapon.SetModelSimple(model)
                                weapon.SetCustomViewModelModelIndex(modelIndex);
                                NetProps.SetPropInt(weapon, "m_iViewModelIndex", modelIndex );
                            }
                        }
                }
                else  if ((player.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (player.GetTeam() == 2))
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if ((weapon.GetClassname() == "tf_weapon_pda_spy") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_pda_spy"))
                            {
                                viewmodel.SetModelSimple("models/weapons/v_models/v_pda_spy.mdl")
                            }
                            else if ((weapon.GetClassname() == "tf_weapon_invis"))
                            {
                                local model
                                local weaponindex = NetProps.GetPropInt(weapon, "m_iWorldModelIndex")
                                if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_spy.mdl") ) {model = "models/weapons/v_models/v_watch_spy.mdl";}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_pocket_spy.mdl")) {model = "models/weapons/v_models/v_watch_pocket_spy.mdl";}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_watch_leather_spy.mdl")) {model = "models/weapons/v_models/v_watch_leather_spy.mdl";}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_ttg_watch_spy.mdl")){model = "models/weapons/v_models/v_ttg_watch_spy.mdl";}
                                else if (weaponindex == GetModelIndex("models/weapons/v_models/v_hm_watch/v_hm_watch.mdl")){model = "models/weapons/v_models/v_ttg_watch_spy.mdl";}
                                else if (weaponindex == GetModelIndex("models/workshop_partner/weapons/v_models/v_hm_watch/v_hm_watch.mdl")){model = "models/weapons/v_models/v_ttg_watch_spy.mdl";}

                                local modelIndex = GetModelIndex( model )
                                weapon.SetModelSimple(model)
                                weapon.SetCustomViewModelModelIndex(modelIndex);
                                NetProps.SetPropInt(weapon, "m_iViewModelIndex", modelIndex );
                            }
                        }
                }
                else if ((player.GetPlayerClass() == TF_PLAYERCLASS_HEAVY) && (player.GetTeam() == 3) && player.IsMiniBoss())
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if ((weapon.GetClassname() == "tf_weapon_minigun") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_minigun"))
                            {

                                if (viewmodel.GetSequence() == viewmodel.LookupSequence("m_spool_up"))
                                {
                                    //player.GetScriptScope().WeaponSoundDelay = 0
                                    if (Time() > player.GetScriptScope().WeaponSoundDelay)
                                    {
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantHeavyGunWindUp`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSoundDelay = 1 + Time()
                                        player.GetScriptScope().WeaponSpinIdleSoundDelay = 0
                                        player.GetScriptScope().WeaponSpinFireSoundDelay = 0
                                        weapon.StopSound("MVM.GiantHeavyGunSpin");
                                        weapon.StopSound("MVM.GiantHeavyGunFire");
                                    }
                                }
                                else if (viewmodel.GetSequence() == viewmodel.LookupSequence("m_spool_down"))
                                {
                                    if (Time() > player.GetScriptScope().WeaponSoundDelay)
                                    {
                                        weapon.StopSound("MVM.GiantHeavyGunSpin");
                                        weapon.StopSound("MVM.GiantHeavyGunFire");
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantHeavyGunWindDown`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSoundDelay = 2 + Time()
                                        player.GetScriptScope().WeaponSpinIdleSoundDelay = 0
                                        player.GetScriptScope().WeaponSpinFireSoundDelay = 0
                                    }
                                }
                                else if (viewmodel.GetSequence() == viewmodel.LookupSequence("m_spool_idle"))
                                {
                                    if (Time() > player.GetScriptScope().WeaponSpinIdleSoundDelay)
                                    {
                                        weapon.StopSound("MVM.GiantHeavyGunFire");
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantHeavyGunSpin`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSpinIdleSoundDelay = 9999
                                        player.GetScriptScope().WeaponSpinFireSoundDelay = 0
                                    }
                                }
                                else if (viewmodel.GetSequence() == viewmodel.LookupSequence("m_fire"))
                                {
                                    if (Time() > player.GetScriptScope().WeaponSpinFireSoundDelay)
                                    {
                                        weapon.StopSound("MVM.GiantHeavyGunSpin");
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantHeavyGunFire`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSpinFireSoundDelay = 9999
                                        player.GetScriptScope().WeaponSpinIdleSoundDelay = 0
                                    }
                                }
                            }
                        }
                }
                else if ((player.GetPlayerClass() == TF_PLAYERCLASS_PYRO) && (player.GetTeam() == 3) && player.IsMiniBoss())
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if ((weapon.GetClassname() == "tf_weapon_flamethrower") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_flamethrower"))
                            {

                                if (viewmodel.GetSequence() == viewmodel.LookupSequence("ft_fire"))
                                {
                                    //player.GetScriptScope().WeaponSoundDelay = 0
                                    if (Time() > player.GetScriptScope().WeaponSoundDelay)
                                    {
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantPyro_FlameLoop`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSoundDelay = 99999
                                    }
                                }
                                else
                                {
                                        weapon.StopSound("MVM.GiantPyro_FlameLoop");
                                        player.GetScriptScope().WeaponSoundDelay = 0
                                }
                            }
                        }
                }
                else if ((player.GetPlayerClass() == TF_PLAYERCLASS_SOLDIER) && (player.GetTeam() == 3) && player.IsMiniBoss())
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if ((weapon.GetClassname() == "tf_weapon_rocketlauncher") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_rocketlauncher"))
                            {

                                if (viewmodel.GetSequence() == viewmodel.LookupSequence("dh_fire"))
                                {
                                    local fire_time = NetProps.GetPropFloat(weapon, "m_flLastFireTime");
                                    if (fire_time > player.GetScriptScope().WeaponSoundDelay)
                                    {
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantSoldierRocketShoot`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSoundDelay = fire_time;
                                    }
                                }
                            }
                        }
                }
                else if ((player.GetPlayerClass() == TF_PLAYERCLASS_DEMOMAN) && (player.GetTeam() == 3) && player.IsMiniBoss())
                {
                        if ((weapon != null) && (player.GetActiveWeapon() != null))
                        {
                            if ((weapon.GetClassname() == "tf_weapon_grenadelauncher") && (player.GetActiveWeapon().GetClassname() == "tf_weapon_grenadelauncher"))
                            {

                                if (viewmodel.GetSequence() == viewmodel.LookupSequence("g_fire"))
                                {
                                    local fire_time = NetProps.GetPropFloat(weapon, "m_flLastFireTime");
                                    if (fire_time > player.GetScriptScope().WeaponSoundDelay)
                                    {
                                        EntFireByHandle(self, "RunScriptCode", "PlayWeaponSound(activator,`MVM.GiantDemoman_Grenadeshoot`)", 0.01, weapon, weapon);
                                        player.GetScriptScope().WeaponSoundDelay = fire_time;
                                    }
                                }
                            }
                        }
                }
            }
        }
    }
    EntFireByHandle(self, "RunScriptCode", "SlappyThink()", 0.1, null, null)
}

function PlayWeaponSound(weapon, name)
{
    weapon.EmitSound(name);
}

