::mainScript <- self
::mainScope <- self.GetScriptScope()

::miniroundnum <- 0


IncludeScript("sprinklesscripts/lib/sprinkles_util.nut")

::DEBUG <- IsInDebugMode()

IncludeScript("stopthattank/give_tf_weapon/_master.nut")

IncludeScript("stopthattank/TankHandler.nut")
IncludeScript("stopthattank/BossGiant.nut")
IncludeScript("stopthattank/MainModels.nut")
IncludeScript("stopthattank/BombDeploy.nut")
IncludeScript("stopthattank/RobotHotHand.nut")
IncludeScript("stopthattank/RobotDeathSound.nut")
IncludeScript("stopthattank/RobotImpactSound.nut")
//IncludeScript("stopthattank/RobotWeaponSounds.nut")
IncludeScript("stopthattank/GiantWeaponsStats.nut")
IncludeScript("stopthattank/reviveMarker.nut")
IncludeScript("stopthattank/VoicelineRobotHelper.nut")
//IncludeScript("stopthattank/StopThatTankTournament.nut")

if(FileToString("tankkills.txt") == null)
{
	StringToFile("tankkills.txt", "0")
	printl("TANK KILLS NOW TRACKING!")
}

::revive_table <- [
    [ 0, 125 ],
    [ 1, 125 ],
    [ 3, 200 ],
    [ 7, 175 ],
    [ 4, 175 ],
    [ 6, 300 ],
    [ 9, 150 ],
    [ 5, 150 ],
    [ 2, 125 ],
    [ 8, 125 ]
]

::SmallFootsteps <- function(player)
{
    player.AddCustomAttribute("override footstep sound set", 7, -1);
    NetProps.SetPropInt(player,"m_bloodColor", -1);
}

::RobotBloodHide <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    NetProps.SetPropInt(player, "m_bloodColor", -1)
}

::HumanBloodShow <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    NetProps.SetPropInt(player, "m_bloodColor", 0)
}

for (local entity; entity = Entities.FindByName(entity, "revivesprites");) //is this needed?
{
    if (entity != null)
	    entity.Destroy()
}

IncludeScript("stopthattank/VoicelineRobotHelper.nut")

function Precache()
{
    if ( !("VoicelineRobotHelper" in getroottable()) )
    {
        ::VoicelineRobotHelper <- {};

        foreach (snd in PrecacheSounds)
        {
            self.PrecacheSoundScript(snd) //those text indentations matter a lot so keep an eye on them
        }
    }
}

function Think()
{
	m_iRedPlayersAmount = redplayerarray.len()

    local ent = null;
    while (ent = Entities.FindByClassname(ent, "instanced_scripted_scene")) //this entity doesn't even exist in hammer, don't bother trying to understand it
    {
        local owner = NetProps.GetPropEntity(ent, "m_hOwner"); //who let out the specific voice line (aka probably you)
        if (owner != null) //if both exists and is in team blu
		{
            if ((owner.GetClassname() != "tf_taunt_prop") && (owner.GetClassname() == "player"))
            {
                if ((owner.GetTeam() == 3) || ((owner.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (owner.InCond(TF_COND_DISGUISED))))
                {
                    owner.AddCustomAttribute("voice pitch scale", 0.0, -1.0); //ficool2 used this to completely mute the player's voiceline. So that the human speech don't overlap with the new robotic one (and also to not accidentally let the robot let out human sounds which you didn't happen to replace yet.)
                    OnPlayerVoiceline(owner, ent);
                }
                else if((owner.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (!owner.InCond(TF_COND_DISGUISED)))
                {
                    owner.RemoveCustomAttribute("voice pitch scale"); //ficool2 used this to completely mute the player's voiceline. So that the human speech don't overlap with the new robotic one (and also to not accidentally let the robot let out human sounds which you didn't happen to replace yet.)
                }
            }
		}
        ent.KeyValueFromString("classname", "_scene"); //I seriously don't get this part either :shrug:
    }
    return -1 //ah there's the tick delay we mentioned earlier
}

::EmitPlayerVoiceline <- function(player, name)
{
    player.EmitSound(name);
}

// precache each footstep/weapon sound (decided to just use precache sound since there isn't a lot)

PrecacheSound("^mvm/mvm_deploy_giant.wav")
PrecacheSound("^mvm/mvm_deploy_small.wav")
PrecacheSound("^mvm/mvm_fallpain01.wav")
PrecacheSound("^mvm/mvm_fallpain02.wav")
PrecacheSound("^mvm/mvm_bomb_warning.wav")
PrecacheSound("^mvm/mvm_bomb_explode.wav")
PrecacheSound("^mvm/mvm_cpoint_klaxon.wav")

// Blu robot voice line array

::OnPlayerVoiceline <- function(player, scene)
{
    local name = null
    local vcdpath  = NetProps.GetPropString(scene, "m_szInstanceFilename")
    if (vcdpath)
    {
        for (local i = vcdpath.len() - 1, endindex = null; i >= 0; --i)
        {
            if (vcdpath[i] == 46) // '.'
                endindex = i
            else if (vcdpath[i] == 47 && endindex) // '/'
            {
                name = vcdpath.slice(i + 1, endindex);
                break; // thanks to Mince on discord for providing this part of code
            }
        }
    }

    if(name == null)
        return;



    //taunts
    if(!((name[0] >= '0') && (name[0] <= '9')))
    {
        if (name.tostring().tolower() != "idleloop01")
        {

        }
    }
    //non taunts
    if ((name[0] >= '0') && (name[0] <= '9'))
    {
        local index = name.tointeger();
        local playerClass
        if((player.GetPlayerClass() == TF_PLAYERCLASS_SPY) && (player.InCond(TF_COND_DISGUISED)))
        {
            playerClass = NetProps.GetPropInt(player,"m_Shared.m_nDisguiseClass")
        }
        else
        {
            playerClass = player.GetPlayerClass()
        }
        foreach (vcdClasslist in VCDLists[playerClass])
        {
            local index = name.tointeger()
            foreach (vcd in vcdClasslist)
            {
                if (index == vcd[0])
                {
                    EntFireByHandle(self, "RunScriptCode", "EmitPlayerVoiceline(activator,`"+vcd[1]+"`)", 0.02, player, player);
                    break;
                }
            }
        }
    }
}

function OnPostSpawn()
{
    Convars.SetValue("mp_tournament_redteamname", "MANN CO.")
    Convars.SetValue("mp_tournament_blueteamname", "GRAY GRAVEL CO.")
    CaptureZoneThink() //make a fake think so we don't override the main one!
    BombDeployPostSpawn()
    TankPostSpawn()
    SlappyThink()

	AddThinkToEnt(self, "Think")
}

::MedicRage <- function(player)
{
    player.AddCustomAttribute("generate rage on heal", 1, -1)
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////


    OnGameEvent_player_spawn = function(params)
    {
        if (!("userid" in params))
        return
        local player = GetPlayerFromUserID(params.userid)
        ModelSpawn(params)

        AddThinkToEnt(player,"PowerUpThink") //should rename this to the player think. handles the powerup timer and also replacing viewmodels.


        if (player.GetTeam() == TF_TEAM_BLUE)
        {
            EntFireByHandle(self, "runscriptcode", "SmallFootsteps(activator)", 0.1, player, player)
            RobotBloodHide(params)
            SlappyHide(params)
            EntFireByHandle(self, "runscriptcode", "RomeVision(activator)", 0.1, player, player)
        }
        if (player.GetTeam() == TF_TEAM_RED)
        {
            if(player.GetPlayerClass() == TF_PLAYERCLASS_MEDIC)
            {
                EntFireByHandle(self, "runscriptcode", "MedicRage(activator)", 0.1, player, player)
            }

            HumanBloodShow(params)
        }
        EntFireByHandle(self, "runscriptcode", "HealthReset(activator)", 0.1, player, player)
    }

    OnScriptHook_OnTakeDamage = function(params)
    {
        local player = params.const_entity
        if (player.GetTeam() == 3)
        {
            local m_vecDamageLocation = params.damage_position

            //added this check because certian weapons just don't like to behave and send a proper damage location
            //check to see if its somewhat near world center with a 0.1 degree tolorance
            if (CloseEnoughVelocity(params.damage_position, Vector() , 0.1))
            {
                m_vecDamageLocation = player.GetCenter()
            }

            if (player.GetMaxHealth() > 1)
            {
                if ( player.GetHealth() / player.GetMaxHealth() > 0.3 )
                {
                    DispatchParticleEffect("bot_impact_light", m_vecDamageLocation, Vector(0, 0, 0));
                }
                else
                {
                    DispatchParticleEffect( "bot_impact_heavy", m_vecDamageLocation, Vector(0, 0, 0) );
                }
            }
            if (player.GetClassname() == "player")
            {
                if(player.IsMiniBoss() && (params.damage_custom == 2))
                {
                    printl(player.GetMaxHealth() * 0.2)
                    player.TakeDamageCustom(params.inflictor, params.attacker, params.weapon, params.damage_force, params.damage_position, player.GetMaxHealth() * 0.2, DMG_CLUB, 0);
                }
            }
            //RobotBloodDecal(params)
            PlayerImpact(params)
            //RobotWeaponImpact(params)
        }
    }

    OnGameEvent_post_inventory_application = function(params)
    {
        if (!("userid" in params)) return;
        if ( "early_out" in params) return;	//for recalculating bodygroups in "CTFPlayer.CreateCustomWearable()"
    //Defines player handle as player
        local player = GetPlayerFromUserID(params.userid);

    // REQUIRED ( Must be at the beginning! )
        GTFW.WriteTableToWeaponScope_EntireLoadout(player);
        player.GTFW_Cleanup();	// Anytime a weapon or wearable is created, it won't delete by itself!! This function will remove those entities for you.
        local playerScope = player.GetScriptScope();
    //	playerScope.GTFW_playerOriginalClassModel <- player.GetModelName();
        if ( "GTFW_playerOriginalClassModel" in playerScope ) GTFW.SetCustomModelWithClassAnimations(player,playerScope.GTFW_playerOriginalClassModel);


    // OPTIONAL
    // - CUSTOM CLASS ARMS FOR FIRST-PERSON
    //	 As it says on the tin. This one is only if you want to restore custom class arms after touching resupply.
    //	 You can set custom arms with function player.SetCustomClassArms(my_model_path, true)
    //	  If you set param 2 to `true`, it'll save the arms in memory to be loaded by the below function.
    //	  Otherwise, setting to `false` or just not including it won't save it in memory. It'll only last until GTFW_Cleanup() removes it.
        EntFireByHandle(player,"RunScriptCode","self.GTFW_RestoreCustomClassArms()",0.0,player,player);

        if (player.GetTeam() == TF_TEAM_BLUE)
        {
            SlappyHide(params)
        }
    }

	OnGameEvent_player_death = function(params)
    {

        if (!("userid" in params)) return;

        //Defines player handle as player
        local hPlayer = GetPlayerFromUserID(params.userid);
         // Updates ragdoll to the player's actual class.
        hPlayer.ValidateScriptScope();
        local playerScope = hPlayer.GetScriptScope();
        if ( "GTFW_playerOriginalClassModel" in playerScope ) hPlayer.SetCustomModelWithClassAnimations(playerScope.GTFW_playerOriginalClassModel);

        if (hPlayer.GetTeam() == TF_TEAM_RED)
        {
            local index = hPlayer.GetPlayerClass()
            foreach (player_class in revive_table)
            {
                if (index == player_class[0])
                {
                    local cReviveMarker = reviveMarker()
                    cReviveMarker.spawnReviveMarker(hPlayer, player_class[1])
                }
            }
        }

        if (hPlayer.GetTeam() == TF_TEAM_BLUE)
        {
            PlayerDeathLineStandard(params)
            if (AllowDeploy == false)
            {
                BombDeployStopped(hPlayer)
            }
            if(m_hFlagHolder == hPlayer)
            {
                m_bAllowBannerEffect = false
                m_hFlagHolder = null
                PowerupTimer = 0
            }
        }

        if (hPlayer.IsMiniBoss())
        {
            m_bAllowBannerEffect = false
            m_hFlagHolder = null
            PowerupTimer = 0
            GiantDeath(params)
        }

        GiantDeath(params)
    }

	OnGameEvent_teamplay_round_start = function(params)
    {
        local cosmetic = null
        while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
        {
            cosmetic.SetDrawEnabled(true)
        }
    }

	OnGameEvent_teamplay_round_win = function(params)
    {
		if (params.full_round == false)
        {
            miniroundnum++
        }
        for (local i = 1; i <= MaxPlayers; i++ )
        {
            local player = PlayerInstanceFromIndex(i)
            if (player == null)
            continue;
            if (player.IsMiniBoss())
            {
                GiantReset(player)
            }
        }
        local cosmetic = null
        while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
        {
            cosmetic.SetDrawEnabled(true)
        }
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)