local GameRules = Entities.FindByClassname(null, "tf_gamerules");
local MAX_CLIENTS = MaxClients().tointeger();

// 0 - not ready
// 1 - ready
local ready_state = 1;

local red_check = false;
local blue_check = false;

for (local i = 1; i <= MAX_CLIENTS; i++)
{
	local player = PlayerInstanceFromIndex(i);
	if (!player)
		continue;
		
	local team = player.GetTeam();
	if (!(team & 2))
		continue;
	
	if (team == 2)
	{
		if (red_check)
			continue;
		red_check = true;
	}
	else if (team == 3)
	{
		if (blue_check)
			continue;
		blue_check = true;
	}
	
	if (NetProps.GetPropBoolArray(GameRules, "m_bTeamReady", team))
		continue;
	
	NetProps.SetPropBoolArray(GameRules, "m_bTeamReady", ready_state == 1, team);
	
	SendGlobalGameEvent("tournament_stateupdate",
	{
		userid = player.entindex(),
		readystate = ready_state,
		namechange = 0,
		oldname = " ",
		newname = " ",
		
	});

	if (ready_state == 0)
	{
		NetProps.SetPropFloat(GameRules, "m_flRestartRoundTime", -1.0);
		NetProps.SetPropBool(GameRules, "m_bAwaitingReadyRestart", true);
	}
}