IncludeScript("stopthattank/vs_math.nut")

local m_exhaustAttachment = -1;
local m_isSmoking = false;
local m_bIsPlayerKilled = true;
local m_bPlayedHalfwayAlert = false;
local m_bPlayedNearAlert = false;
local m_damageModelIndex = 0;
local m_nDeathAnimPick = 1;
local m_flDroppingStart = 0.0;
local m_flSpawnTime = 0.0;
local m_isDroppingBomb = false;
local TANK_DAMAGE_MODEL_COUNT = 4
local TANK_DEFAULT_HEALTH = 1000
local m_fTotalDistance = 0.0;
local m_flLastPingTime = 0.0
local m_CumulativeDistances = []
local precalctracklength = m_iTrackLength
local m_flSpeed = TANKSPEED
local m_isBombDropped = false
local SmokeTrace = {}

local TANK_BODY = "models/bots/boss_bot/boss_tank.mdl"
local TANK_BODY_DAMAGE1 =	"models/bots/boss_bot/boss_tank_damage1.mdl"
local TANK_BODY_DAMAGE2 =	"models/bots/boss_bot/boss_tank_damage2.mdl"
local TANK_BODY_DAMAGE3 =	"models/bots/boss_bot/boss_tank_damage3.mdl"

local TANK_BODY_ROME = "models/bots/tw2/boss_bot/boss_tank.mdl"
local TANK_BODY_DAMAGE1_ROME =	"models/bots/tw2/boss_bot/boss_tank_damage1.mdl"
local TANK_BODY_DAMAGE2_ROME =	"models/bots/tw2/boss_bot/boss_tank_damage2.mdl"
local TANK_BODY_DAMAGE3_ROME =	"models/bots/tw2/boss_bot/boss_tank_damage3.mdl"

local TANK_LEFT_TRACK_MODEL = "models/bots/boss_bot/tank_track_L.mdl"
local TANK_RIGHT_TRACK_MODEL = "models/bots/boss_bot/tank_track_R.mdl"
local TANK_BOMB = "models/bots/boss_bot/bomb_mechanism.mdl"
local TANK_DESTRUCTION = "models/bots/boss_bot/boss_tank_part1_destruction.mdl"

local TANK_LEFT_TRACK_MODEL_ROME = "models/bots/tw2/boss_bot/tank_track_L.mdl"
local TANK_RIGHT_TRACK_MODEL_ROME = "models/bots/tw2/boss_bot/tank_track_R.mdl"
local TANK_BOMB_ROME = "models/bots/boss_bot/bomb_mechanism.mdl"
local TANK_DESTRUCTION_ROME	= "models/bots/tw2/boss_bot/boss_tank_part1_destruction.mdl"

local MVM_DESTROY_TANK_QUICKLY_TIME = 25.0

local m_flLastTankAlert = 0.0;

function DestroyIfAtCapturePoint( controlpoint )
{
	if (AmountCapped == controlpoint)
	{
		self.TakeDamage(999999, 1, Entities.First())
	}
}

function ChangeDestructionAnimation( animation )
{
	m_nDeathAnimPick = animation
}

function Precache()
{
	//tank
	self.PrecacheModel(TANK_BODY)
	self.PrecacheModel(TANK_BODY_DAMAGE1)
	self.PrecacheModel(TANK_BODY_DAMAGE2)
	self.PrecacheModel(TANK_BODY_DAMAGE3)

	self.PrecacheModel(TANK_LEFT_TRACK_MODEL)
	self.PrecacheModel(TANK_RIGHT_TRACK_MODEL)
	self.PrecacheModel(TANK_BOMB)
	self.PrecacheModel(TANK_DESTRUCTION)
	//tank rome
	self.PrecacheModel(TANK_BODY_ROME)
	self.PrecacheModel(TANK_BODY_DAMAGE1_ROME)
	self.PrecacheModel(TANK_BODY_DAMAGE2_ROME)
	self.PrecacheModel(TANK_BODY_DAMAGE3_ROME)

	self.PrecacheModel(TANK_LEFT_TRACK_MODEL_ROME)
	self.PrecacheModel(TANK_RIGHT_TRACK_MODEL_ROME)
	self.PrecacheModel(TANK_BOMB_ROME)
	self.PrecacheModel(TANK_DESTRUCTION_ROME)
	//particles
	PrecacheParticle( "smoke_train" );
	PrecacheParticle( "bot_impact_light" );
	PrecacheParticle( "bot_impact_heavy" );
	//sounds
	self.PrecacheScriptSound( "MVM.TankEngineLoop" );
	self.PrecacheScriptSound( "MVM.TankPing" );
	self.PrecacheScriptSound( "MVM.TankDeploy" );
	self.PrecacheScriptSound( "MVM.TankStart" );
	self.PrecacheScriptSound( "MVM.TankEnd" );
	self.PrecacheScriptSound( "MVM.TankSmash" );

}

function FollowEntity(pBaseEntity, bBoneMerge, pEntityToMerge )
{
	if (pEntityToMerge)
	{
		EntFireByHandle(pEntityToMerge, "SetParent", "!activator", 0, pBaseEntity, pBaseEntity);
		pEntityToMerge.SetMoveType(0, 0);

		if ( bBoneMerge )
		{
			NetProps.SetPropInt(pEntityToMerge,"m_fEffects", 129);
		}

		pEntityToMerge.SetCollisionGroup(0)
	}
}
m_startNode <- null
m_endNode <- null
m_goalNode <- null
m_bomb <- null
m_exhaustSmoke <- null
m_body <- null
m_nNodeNumber <- 0
m_lastHealth <- 0
m_leftTracks <- null
m_rightTracks <- null
m_lastLeftTrackPos <- Vector(0, 0, 0)
m_lastRightTrackPos <- Vector(0, 0, 0)
m_vCollisionMins <- Vector(0, 0, 0)
m_vCollisionMaxs <- Vector(0, 0, 0)
local trackthingy = 0
//--------------------------------------------------------------------------------------
function Spawn()
{
	SetPropString(self, "m_iClassname", "tank_boss")


	self.SetTeam( TF_TEAM_BLUE );

	m_damageModelIndex = 0;
	self.SetModel( TANK_BODY );
	m_lastHealth = self.GetMaxHealth();

	m_vCollisionMaxs =  self.GetBoundingMaxs();

	NetProps.SetPropInt(self,"m_nRenderMode", 10);
	//NetProps.SetPropInt(self,"m_fEffects", 32);

	m_leftTracks = Entities.CreateByClassname("prop_dynamic");
	if ( m_leftTracks )
	{
		m_leftTracks.SetModel( TANK_LEFT_TRACK_MODEL );
		m_leftTracks.SetAbsAngles(self.GetAbsAngles())
		NetProps.SetPropIntArray(m_leftTracks, "m_nModelIndexOverrides", GetModelIndex(TANK_LEFT_TRACK_MODEL), 3);
		NetProps.SetPropIntArray(m_leftTracks, "m_nModelIndexOverrides", GetModelIndex(TANK_LEFT_TRACK_MODEL_ROME), 2);
		// bonemerge into our model
		FollowEntity(self, true, m_leftTracks);

		local animSequence = m_leftTracks.LookupSequence( "forward" );
		if ( animSequence )
		{
			m_leftTracks.SetSequence( animSequence );
			m_leftTracks.SetPlaybackRate( 1.0 );
			m_leftTracks.SetCycle( 0 );
			m_leftTracks.DispatchAnimEvents(m_leftTracks);
		}

		m_lastLeftTrackPos = m_leftTracks.GetOrigin();
	}

	m_rightTracks = Entities.CreateByClassname("prop_dynamic");
	if ( m_rightTracks )
	{
		m_rightTracks.SetModel( TANK_RIGHT_TRACK_MODEL );
		m_rightTracks.SetAbsAngles(self.GetAbsAngles())
		NetProps.SetPropIntArray(m_rightTracks, "m_nModelIndexOverrides", GetModelIndex(TANK_RIGHT_TRACK_MODEL), 3);
		NetProps.SetPropIntArray(m_rightTracks, "m_nModelIndexOverrides", GetModelIndex(TANK_RIGHT_TRACK_MODEL_ROME), 2);

		// bonemerge into our model
		FollowEntity(self, true, m_rightTracks);

		local animSequence = m_rightTracks.LookupSequence( "forward" );
		if ( animSequence )
		{
			m_rightTracks.SetSequence( animSequence );
			m_rightTracks.SetPlaybackRate( 1.0 );
			m_rightTracks.SetCycle( 0 );
			m_rightTracks.DispatchAnimEvents(m_rightTracks);
		}

		m_lastRightTrackPos = m_rightTracks.GetOrigin();
	}

	m_body = Entities.CreateByClassname("prop_dynamic");
	if ( m_body )
	{
		m_body.SetModel( TANK_BODY );
		m_body.SetSkin(1)
		m_body.SetAbsAngles(self.GetAbsAngles())
		NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY), 3);
		NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_ROME), 2);

		//NetProps.SetPropInt(m_body,"m_nRenderMode", 10);
		local animSequence = m_body.LookupSequence( "movement" );
		if ( animSequence )
		{
			m_body.SetSequence( animSequence );
			m_body.SetPlaybackRate( 1.0 );
			m_body.SetCycle( 0 );
			m_body.DispatchAnimEvents(m_body);
		}
		// bonemerge into our model
		FollowEntity(self, false, m_body );
		m_body.SetOrigin(self.GetOrigin())
	}


	m_bomb = Entities.CreateByClassname("prop_dynamic");
	if ( m_bomb )
	{
		m_bomb.SetModel( TANK_BOMB );
		m_bomb.SetAbsAngles(self.GetAbsAngles())

		// bonemerge into our model
		FollowEntity(self, true, m_bomb );
	}

	m_exhaustAttachment = self.LookupAttachment( "smoke_attachment" );

	m_exhaustSmoke = SpawnEntityFromTable("info_particle_system", {
		effect_name = "smoke_train",
		start_active = 1,
 	})
	if ( m_exhaustSmoke )
	{
		FollowEntity(m_body, false, m_exhaustSmoke );

		EntFireByHandle(m_exhaustSmoke, "SetParentAttachment", "smoke_attachment", 0.1, null, null);
	}

	m_isSmoking = true

	m_goalNode = Entities.FindByName(null, m_sStartTrack)

	// Remember starting node
	m_startNode = m_goalNode;
	m_endNode = m_startNode;
	m_nNodeNumber = 0;

	// Orient the Tank along the path
	if ( m_goalNode != null )
	{
		local pPrevNode = m_goalNode;
		local pNextNode = NetProps.GetPropEntity(pPrevNode, "m_pnext")

		if ( pNextNode )
		{
			local along = pNextNode.GetOrigin() - m_goalNode.GetOrigin();

			// Find last node and calculate cumulative distance
			while( pNextNode )
			{
				along = pNextNode.GetOrigin() - pPrevNode.GetOrigin();
				along.z = 0.0;

				m_fTotalDistance += along.Length();
				m_CumulativeDistances.push( m_fTotalDistance );
				trackthingy++
				pPrevNode = pNextNode;
				pNextNode = NetProps.GetPropEntity(pPrevNode, "m_pnext");
			}
		}
	}

	NetProps.SetPropInt(self,"m_bloodColor", -1);

	m_flLastPingTime = Time();

	self.EmitSound( "MVM.TankEngineLoop" );
	self.EmitSound( "MVM.TankStart" );

	m_vCollisionMins = self.GetBoundingMins();
	m_vCollisionMaxs = self.GetBoundingMaxs();
	m_isDroppingBomb = false;
	m_flDroppingStart = 0.0;
	m_flSpawnTime = Time();

	AddThinkToEnt(self, "TankBossThink")
}
//--------------------------------------------------------------------------------------

function OnPostSpawn()
{
	Spawn()
}

function IntersectionBoxBox(xmins, xmaxs, ymins, ymaxs)
{
    return (xmins.x <= ymaxs.x && xmaxs.x >= ymins.x) &&
           (xmins.y <= ymaxs.y && xmaxs.y >= ymins.y) &&
           (xmins.z <= ymaxs.z && xmaxs.z >= ymins.z);
}


function round(val, decimalPoints)
{
	local f = pow(10, decimalPoints) * 1.0;
	local newVal = val * f;
	newVal = floor(newVal + 0.5)
	newVal = (newVal * 1.0) / f;

	return newVal;
}

local TANK_BODY_TOGGLE = true
local TANK_BODY_DAMAGE1_TOGGLE = true
local TANK_BODY_DAMAGE2_TOGGLE = true
local TANK_BODY_DAMAGE3_TOGGLE = true
local boundcount = 0
local ToggleDeploy = true
function TankBossThink()
{
	if(m_isBombDropped)
		return

	// damage states
	if ( self.GetHealth() != m_lastHealth )
	{

		if ((self.GetHealth() <= (self.GetMaxHealth() * 1)) && (self.GetHealth() >= (self.GetMaxHealth() * 0.76)))
		{
			if (TANK_BODY_TOGGLE)
			{
				TANK_BODY_TOGGLE = false
				m_body.SetModelSimple( TANK_BODY );
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY), 3);
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_ROME), 2);
				local animSequence = m_body.LookupSequence( "movement" );
				if ( animSequence && m_exhaustSmoke)
				{
					m_body.SetSequence( animSequence );
					m_body.SetPlaybackRate( 1.0 );
					m_body.SetCycle( 0 );
					m_body.DispatchAnimEvents(m_body);
				}
			}
		}
		else if ((self.GetHealth() <= (self.GetMaxHealth() * 0.75)) && (self.GetHealth() >= (self.GetMaxHealth() * 0.51)))
		{
			if (TANK_BODY_DAMAGE1_TOGGLE)
			{
				TANK_BODY_DAMAGE1_TOGGLE = false
				m_body.SetModelSimple( TANK_BODY_DAMAGE1 );
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE1), 3);
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE1_ROME), 2);
				local animSequence = m_body.LookupSequence( "movement" );
				if ( animSequence && m_exhaustSmoke)
				{
					m_body.SetSequence( animSequence );
					m_body.SetPlaybackRate( 1.0 );
					m_body.SetCycle( 0 );
					m_body.DispatchAnimEvents(m_body);
				}
			}
		}
		else if ((self.GetHealth() <= (self.GetMaxHealth() * 0.5)) && (self.GetHealth() >= (self.GetMaxHealth() * 0.26)))
		{
			if (TANK_BODY_DAMAGE2_TOGGLE)
			{
				TANK_BODY_DAMAGE2_TOGGLE = false
				m_body.SetModelSimple( TANK_BODY_DAMAGE2 );
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE2), 3);
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE2_ROME), 2);
				local animSequence = m_body.LookupSequence( "movement" );
				if ( animSequence && m_exhaustSmoke)
				{
					EntFireByHandle(m_exhaustSmoke, "SetParentAttachment", "smoke_attachment1" , 0.01, null, null);
					m_body.SetSequence( animSequence );
					m_body.SetPlaybackRate( 1.0 );
					m_body.SetCycle( 1 );
					m_body.DispatchAnimEvents(m_body);
				}
			}
		}
		else if ((self.GetHealth() <= (self.GetMaxHealth() * 0.25)) && (self.GetHealth() >= (self.GetMaxHealth() * 0)))
		{
			if (TANK_BODY_DAMAGE3_TOGGLE)
			{
				TANK_BODY_DAMAGE3_TOGGLE = false
				m_body.SetModelSimple( TANK_BODY_DAMAGE3 );
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE3), 3);
				NetProps.SetPropIntArray(m_body, "m_nModelIndexOverrides", GetModelIndex(TANK_BODY_DAMAGE3_ROME), 2);
				EntFireByHandle(m_exhaustSmoke, "SetParentAttachment", "smoke_attachment1" , 0.01, null, null);
				local animSequence = m_body.LookupSequence( "movement" );
				if ( animSequence && m_exhaustSmoke)
				{
					m_body.SetSequence( animSequence );
					m_body.SetPlaybackRate( 1.0 );
					m_body.SetCycle( 0 );
					m_body.DispatchAnimEvents(m_body);
				}
			}
		}
	}
	// left/right track speed
	local trackMaxSpeed = 80.0;
	local trackOffset = 56.221;

	local trackCenter

	if ( m_leftTracks )
	{
		local trackCenter = m_leftTracks.GetCenter() - (m_body.GetRightVector() * trackOffset);

		local speed = (trackCenter - m_lastLeftTrackPos).Length() / FrameTime();
		if ( speed >= trackMaxSpeed )
		{
			m_leftTracks.SetPlaybackRate( 1.0 );
		}
		else
		{
			m_leftTracks.SetPlaybackRate( speed / trackMaxSpeed );
		}

		m_lastLeftTrackPos = trackCenter;
	}

	if ( m_rightTracks )
	{
		local trackCenter = m_rightTracks.GetOrigin() - (m_body.GetRightVector() * trackOffset);

		local speed = (trackCenter - m_lastRightTrackPos).Length() / FrameTime();

		if ( speed >= trackMaxSpeed )
		{
			m_rightTracks.SetPlaybackRate( 1.0 );
		}
		else
		{
			m_rightTracks.SetPlaybackRate( speed / trackMaxSpeed );
		}

		m_lastRightTrackPos = trackCenter;
	}

	if ( m_goalNode != null )
	{
		local toGoal = m_goalNode.GetOrigin() - self.GetOrigin();
		toGoal.z = 0.0;
		local range = toGoal.Norm();

		if ( tf_gamerules )
		{
			if ( m_nNodeNumber <= 0 )
			{

			}
			else
			{
				local fBaseDistance = m_CumulativeDistances[ m_nNodeNumber - 1 ];
				local fDistanceFromPreviousToNext = m_CumulativeDistances[ m_nNodeNumber - 1] - fBaseDistance;
				local fDistanceTraveled = fBaseDistance + ( fDistanceFromPreviousToNext - range );
				local fDistancePercent = fDistanceTraveled / m_fTotalDistance;


				NetProps.SetPropFloat(m_eTrainWatcher, "m_flTotalProgress", fDistancePercent)
				if ( m_flLastTankAlert + 5.0 < Time() )
				{
					if ( !m_bPlayedNearAlert && fDistancePercent > 0.75)
					{
						EntFireByHandle(tf_gamerules, "PlayVO", "Announcer.MVM_Tank_Alert_Near_Hatch", 0.0, null, null);
						m_flLastTankAlert = Time();
						m_bPlayedNearAlert = true;
					}
					else if ( !m_bPlayedHalfwayAlert && fDistancePercent > 0.5)
					{
						EntFireByHandle(tf_gamerules, "PlayVO", "Announcer.MVM_Tank_Alert_Halfway", 0.0, null, null);

						m_flLastTankAlert = Time();
						m_bPlayedHalfwayAlert = true;
					}
				}
			}
		}

		if ( range < 20.0 )
		{
			// reached node

			EntFireByHandle(m_goalNode, "inpass", "", 0.05, self, self);

			if (m_goalNode == Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[" + AmountCapped + "]")))
			{
				if (AmountCappedMax != AmountCapped + 1)
				{
					AmountCapped++
				}
			}

			m_goalNode = NetProps.GetPropEntity(m_goalNode, "m_pnext")
			m_nNodeNumber++;

			if ( m_goalNode == null && m_bomb )
			{
				//DevMsg( "Tank's final position: %.2f %.2f %.2f", GetAbsOrigin().x, GetAbsOrigin().y, GetAbsOrigin().z );

				// reached end of track - deploy the bomb
				local animSequence = m_bomb.LookupSequence( "deploy" );
				if ( animSequence )
				{
					m_bomb.SetSequence( animSequence );
					m_bomb.SetPlaybackRate( 1.0 );
					m_bomb.SetCycle( 0 );
					m_body.DispatchAnimEvents(m_bomb);
				}

				local animSequencebody = m_body.LookupSequence( "deploy" );
				if ( animSequencebody )
				{
					m_body.SetSequence( animSequencebody );
					m_body.SetPlaybackRate( 1.0 );
					m_body.SetCycle( 0 );
					m_body.DispatchAnimEvents(m_body);
				}

				if (m_flLastTankAlert + 5.0 < Time())
				{
					EntFireByHandle(tf_gamerules, "PlayVO", "Announcer.MVM_Tank_Alert_Deploying", 0.0, null, null);
					m_flLastTankAlert = Time();
					m_bPlayedNearAlert = true;
				}

				m_isDroppingBomb = true;
				if(ToggleDeploy)
				{
					m_flDroppingStart = Time() + 8;
					ToggleDeploy = false
				}

				self.StopSound( "MVM.TankEngineLoop" );

				self.EmitSound( "MVM.TankDeploy" );

				HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_TANK_DEPLOYING", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
			}
		}
		if ( m_goalNode )
		{
			local goal = m_goalNode.GetOrigin();

			self.GetLocomotionInterface().SetDesiredSpeed(1000);
			self.GetLocomotionInterface().Approach(goal, 1 );
			self.GetLocomotionInterface().FaceTowards( goal );

			//if ( m_rumbleTimer.IsElapsed() )
			//{
			//	m_rumbleTimer.Start( 0.25f );

				// shake nearby players' screens.
			//	UTIL_ScreenShake( GetAbsOrigin(), 2.0f, 5.0f, 1.0f, 500.0f, SHAKE_START );
			//}
		}
	}

	if ( m_isDroppingBomb && (m_flDroppingStart < Time()) )
	{
		m_isDroppingBomb = false;
		m_isBombDropped = true;
		self.TakeDamage(self.GetMaxHealth(), 1, Entities.First())
		OnDeployBomb()
		EntFireByHandle(tf_gamerules, "PlayVO", "Announcer.MVM_Tank_Planted", 0.0, null, null);
	}

	// if the Tank is driving under something, shut off its smokestack
	if ( (m_exhaustAttachment > 0) && m_exhaustSmoke && !m_isDroppingBomb)
	{
		SmokeTrace =
		{
			start = m_exhaustSmoke.GetOrigin(),
			end = Vector(m_exhaustSmoke.GetOrigin().x,m_exhaustSmoke.GetOrigin().y,m_exhaustSmoke.GetOrigin().z + 300),
			mask = 16395,
		}

		TraceLineEx(SmokeTrace);
		//DebugDrawLine(SmokeTrace.startpos, SmokeTrace.endpos, 0, 0, 255, false, 0.1)
		if (SmokeTrace.hit && (SmokeTrace.surface_name != "TOOLS/TOOLSSKYBOX"))
		{
			if ( m_isSmoking )
			{
				EntFireByHandle(m_exhaustSmoke, "Stop", "", 0.1, null, null);
				m_isSmoking = false;
			}
		}
		else if ( !m_isSmoking )
		{
			EntFireByHandle(m_exhaustSmoke, "Start", "", 0.1, null, null);
			m_isSmoking = true;
		}
	}

	for (local building = null; building = Entities.FindByClassname(building, "obj_*");)
    {
        local deltaVector = building.GetOrigin() - self.GetOrigin();
        local distance = deltaVector.Length();
        if (distance < 512)
		{
			if(IntersectionBoxBox(self.GetOrigin() + (self.GetBoundingMins() * 0.98), self.GetOrigin() + (self.GetBoundingMaxs() * 0.98), building.GetOrigin() + building.GetBoundingMins(), building.GetOrigin() + building.GetBoundingMaxs()))
			{
				building.TakeDamage(999999, 1, Entities.First())
			}
		}
    }

	local entity = null
	while (entity = Entities.FindByClassname(entity, "player"))
	{
		if(IntersectionBoxBox(self.GetOrigin() + (self.GetBoundingMins() * 0.98), self.GetOrigin() + (self.GetBoundingMaxs() * 0.98), entity.GetOrigin() + entity.GetBoundingMins(), entity.GetOrigin() + entity.GetBoundingMaxs()))
		{
			entity.TakeDamageCustom(self, self, self, Vector(0,0,0), Vector(0,0,0), 99999.0, 1, 0);
		}
	}

	UpdateCollisionBounds();
	UpdatePingSound();

	return -1
}

function UpdateCollisionBounds()
{

	// When the tank is at a diagonal angle we don't want the bounds to bloat too far
	local flDiagonalShrinkMultiplier = 1.0 - fabs(sin( (DEG2RAD * self.GetAbsAngles().y) * 2.0)) * 0.4;

	local shrink = round(flDiagonalShrinkMultiplier, 2)
	local vMins = Vector(m_vCollisionMins.x * shrink, m_vCollisionMins.y * shrink, m_vCollisionMins.z)
	local vMaxs = Vector(m_vCollisionMaxs.x * shrink, m_vCollisionMaxs.y * shrink, m_vCollisionMaxs.z)

	// Build new world aligned bounds based on how it's rotated
	local rot = matrix3x4_t()
	AngleMatrix(self.GetAbsAngles(), Vector(0, 0, 0), rot );
	local vMinsOut = Vector()
	local vMaxsOut = Vector()
	TransformAABB( rot, vMins, vMaxs, vMinsOut, vMaxsOut );
	self.SetSize( vMinsOut, vMaxsOut );
}

::tankdamageparams <- {}
function Event_Killed( params )
{
	m_bIsPlayerKilled = ((params.attacker.GetClassname() == "player") || (params.inflictor.GetClassname() =="obj_sentrygun"))
	Explode(self);
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////

	OnScriptHook_OnTakeDamage = function(params)
    {
		if (params.const_entity == self)
		{
			tankdamageparams = params

			if (params.damage_custom == 5)
			{
				params.damage = params.damage * 0.25
			}

			if (params.attacker.GetTeam() == TF_TEAM_RED)
			{
				if ( self.GetHealth() / self.GetMaxHealth() > 0.3 )
				{
					DispatchParticleEffect("bot_impact_light", params.damage_position, Vector(0, 0, 0));
				}
				else
				{
					DispatchParticleEffect( "bot_impact_heavy", params.damage_position, Vector(0, 0, 0) );
				}
			}
		}
		if (params.attacker == self)
		{
			params.force_friendly_fire = true
		}
    }

	OnGameEvent_player_death = function(params)
    {
		if(params.weapon == "tank_boss")
		{
			if(KillEaterRank0){	tankrank = "Strange"}
			else if (KillEaterRank1) {
				tankrank = "Unremarkable";
				playlevelupsound()
			}
			else if (KillEaterRank2) {
				tankrank = "Scarcely Lethal";
				playlevelupsound()
			}
			else if (KillEaterRank3) {
				tankrank = "Mildly Menacing";
				playlevelupsound()
			}
			else if (KillEaterRank4) {
				tankrank = "Somewhat Threatening";
				playlevelupsound()
			}
			else if (KillEaterRank5) {
				tankrank = "Uncharitable";
				playlevelupsound()
			}
			else if (KillEaterRank6) {
				tankrank = "Notably Dangerous";
				playlevelupsound()
			}
			else if (KillEaterRank7) {
				tankrank = "Sufficiently Lethal";
				playlevelupsound()
			}
			else if (KillEaterRank8) {
				tankrank = "Truly Feared";
				playlevelupsound()
			}
			else if (KillEaterRank9) {
				tankrank = "Spectacularly Lethal";
				playlevelupsound()
			}
			else if (KillEaterRank10) {
				tankrank = "Gore-Spattered";
				playlevelupsound()
			}
			else if (KillEaterRank11) {
				tankrank = "Wicked Nasty";
				playlevelupsound()
			}
			else if (KillEaterRank12) {
				tankrank = "Positively Inhumane";
				playlevelupsound()
			}
			else if (KillEaterRank13) {
				tankrank = "Totally Ordinary";
				playlevelupsound()
			}
			else if (KillEaterRank14) {
				tankrank = "Face-Melting";
				playlevelupsound()
			}
			else if (KillEaterRank15) {
				tankrank = "Rage-Inducing";
				playlevelupsound()
			}
			else if (KillEaterRank16) {
				tankrank = "Server-Clearing";
				playlevelupsound()
			}
			else if (KillEaterRank17) {
				tankrank = "Epic";
				playlevelupsound()
			}
			else if (KillEaterRank18) {
				tankrank = "Legendary";
				playlevelupsound()
			}
			else if (KillEaterRank19) {
				tankrank = "Australian";
				playlevelupsound()
			}
			else if (KillEaterRank20) {
				tankrank = "Hale's Own";
				playlevelupsound()
			}

			if(FileToString("tankkills.txt") != null)
			{
				StringToFile("tankkills.txt", FileToString("tankkills.txt").tointeger() + 1 + "")
				ClientPrint(null, 3, "\x0799CCFF" + tankrank + " Tank\x07CCCCCC - Kills: " + FileToString("tankkills.txt").tointeger())
			}
		}
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)

::tankrank <- ""

self.PrecacheSoundScript("MVM.TankLevelUp")

::FileTankCounter <- FileToString("tankkills.txt").tointeger() + 1
::KillEaterRank0 <- (FileTankCounter >= 0 && FileTankCounter <= 9)
::KillEaterRank1 <- (FileTankCounter >= 10 && FileTankCounter <= 24)
::KillEaterRank2 <- (FileTankCounter >= 25 && FileTankCounter <= 44)
::KillEaterRank3 <- (FileTankCounter >= 45 && FileTankCounter <= 69)
::KillEaterRank4 <- (FileTankCounter >= 70 && FileTankCounter <= 99)
::KillEaterRank5 <- (FileTankCounter >= 100 && FileTankCounter <= 134)
::KillEaterRank6 <- (FileTankCounter >= 135 && FileTankCounter <= 174)
::KillEaterRank7 <- (FileTankCounter >= 175 && FileTankCounter <= 224)
::KillEaterRank8 <- (FileTankCounter >= 225 && FileTankCounter <= 274)
::KillEaterRank9 <- (FileTankCounter >= 275 && FileTankCounter <= 349)
::KillEaterRank10 <- (FileTankCounter >= 350 && FileTankCounter <= 499)
::KillEaterRank11 <- (FileTankCounter >= 500 && FileTankCounter <= 749)
::KillEaterRank12 <- (FileTankCounter >= 750 && FileTankCounter <= 998)
::KillEaterRank13 <- (FileTankCounter == 999)
::KillEaterRank14 <- (FileTankCounter >= 1000 && FileTankCounter <= 1499)
::KillEaterRank15 <- (FileTankCounter >= 1500 && FileTankCounter <= 2499)
::KillEaterRank16 <- (FileTankCounter >= 2500 && FileTankCounter <= 4999)
::KillEaterRank17 <- (FileTankCounter >= 5000 && FileTankCounter <= 7499)
::KillEaterRank18 <- (FileTankCounter >= 7500 && FileTankCounter <= 7615)
::KillEaterRank19 <- (FileTankCounter >= 7616 && FileTankCounter <= 8499)
::KillEaterRank20 <- (FileTankCounter >= 8500)

::playlevelupsound <- function()
{
	if (FileTankCounter == 10 || FileTankCounter == 25 || FileTankCounter == 45 || FileTankCounter == 70 || FileTankCounter == 100 || FileTankCounter == 135 || FileTankCounter == 175 ||
		FileTankCounter == 225 || FileTankCounter == 275 || FileTankCounter == 350 || FileTankCounter == 500 || FileTankCounter == 750 || FileTankCounter == 999 || FileTankCounter == 1000 ||
		FileTankCounter == 1500 || FileTankCounter == 2500 || FileTankCounter == 5000 || FileTankCounter == 7500 || FileTankCounter == 7616 || FileTankCounter == 8500)
	{
		EmitSoundEx({
					sound_name = "MVM.TankLevelUp",
					origin = self.GetCenter(),
					sound_level = 0,
					filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL
		})
	}
}

SetDestroyCallback(self, function()
{
	self.StopSound( "MVM.TankEngineLoop" );
	foreach (currencypack in money_table)
    {
        local ent = null
        while ((ent = Entities.FindByClassname(ent, currencypack[0])) != null)
        {
            ent.Destroy()
        }
    }

	if (self.GetHealth() <= 0)
	{
		m_bIsPlayerKilled = ((tankdamageparams.attacker.GetClassname() == "player") || (tankdamageparams.inflictor.GetClassname() =="obj_sentrygun"))
		Explode(self);
	}
});

function Explode(tank)
{
	local pDestruction = SpawnEntityFromTable("tank_destruction", {
		DefaultAnim = "destroy_mvm_deathpit2",
		disableshadows = 1,
		solid = 6,
		angles = tank.GetAbsAngles(),
		origin = tank.GetOrigin(),
 	})
	NetProps.SetPropIntArray(pDestruction, "m_nModelIndexOverrides", GetModelIndex(TANK_DESTRUCTION), 3);
	NetProps.SetPropIntArray(pDestruction, "m_nModelIndexOverrides", GetModelIndex(TANK_DESTRUCTION_ROME), 2);
	pDestruction.SetSequence(m_nDeathAnimPick)
	pDestruction.DispatchAnimEvents(pDestruction)
	if ( m_bIsPlayerKilled )
	{
		EntFireByHandle(tf_gamerules, "PlayVO", "Announcer.MVM_General_Destruction", 0.0, null, null);

		HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_TANK_DEAD", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1"); //TODO add defenders tank busting lines

		EntFireByHandle(mainScript, "RunScriptCode", "OnKilled()", 0.1, null, null);

	}
}

function SetStartingPathTrackNode( nodepath )
{
	m_goalNode = nodepath
}

local TANK_PING_TIME = 5.0

function UpdatePingSound()
{
	if ((Time() - m_flLastPingTime) >= TANK_PING_TIME)
	{
		m_flLastPingTime = Time();
		self.EmitSound( "MVM.TankPing");
	}
}
