//-----------------------------------------------------------------------------
// Purpose: Writes all useful weapon data (maxammo, name, etc) to weapon's scope
//-----------------------------------------------------------------------------


::GTFW.UpdatePropertiesFromTableToTable <- function(table, wepScope) {
	foreach (k, v in table) {
	//	printl(k+" : "+table[k])
		if ( k == "constructor" ) continue
		wepScope[k] <- v;
	}
	GTFW.DevPrint(0,"GTFW.UpdatePropertiesFromTableToTable", "Updated properties for "+table.name+" to another table");
	return wepScope
}


//-----------------------------------------------------------------------------
// Purpose: Writes 
//-----------------------------------------------------------------------------

::GTFW.WriteTableToWeaponScope <- function(player, wep)
{
	if ( type( player ) != "instance" ) return;
	if ( type( wep ) != "instance" ) return;
	
	wep.ValidateScriptScope();
	local wep_scope = wep.GetScriptScope();
	if ( "tf_class" in wep_scope ) return GTFW.DevPrint(0,"WriteTableToWeaponScope", "GTFW Table already in scope of \x22"+wep+"\x22.");
	
	local table = player.GetWeaponTable(wep);
	
	GTFW.DevPrint(0,"WriteTableToWeaponScope", "Writing GTFW table to scope of \x22"+wep+"\x22");
	GTFW.UpdatePropertiesFromTableToTable(table,wep_scope);
}


::GTFW.WriteTableToWeaponScope_EntireLoadout <- function(player=null)
{
//Error if param is null
	if ( player == null || type(player) != "instance" ) {
		GTFW.DevPrint(1,"WriteTableToWeaponScope_EntireLoadout", "Function failed. Parameter is null. Returning null.")
		return null
	}
	
	local AllWeaponsArray = player.GetAllWeapons();
	
	foreach(k, wep in AllWeaponsArray)
		GTFW.WriteTableToWeaponScope(player, wep);
	
	GTFW.DevPrint(0,"WriteTableToWeaponScope_EntireLoadout", "Finished writing to loadout.");
}